#ifndef __CONTACT_INFO__
#define __CONTACT_INFO__

#include "Vector.h"

//Used to hold extra information about a possible collision between objects
class CContactExtraInfo
{
public:
	bool    bNormalHoldsInfo;
	CVector old_Normal;

	bool    bSmallVelocityContact;
};

//Used to hold information about a possible collision between objects
class CContact
{
public:
	bool    bContactExists;

	int     idObjectA;
	int     idObjectB;

	CVector objectA_IntersectionPoint;
	CVector objectB_OutwardNormal;

	//Normal vector direction must be multiplied by Object B's orientation
	//IntersectionPoint must be multiplied by Object A's orientation and then add Object A's Position vector
	//Remember to normalize Normal vector
	//Remember to zero out the (0,1,0) component

	//Extra Info
	CContactExtraInfo Extra;
};

#endif

