#ifndef __LINEAR_PROGRAM_SOLVER__
#define __LINEAR_PROGRAM_SOLVER__

#include "MatrixList.h"

//Expects a matrix that looks like
//row a b c +1 d represents a*x + b*y + c*z <= d
//           0   represents                 ==
//          -1   represents                 >=
//
//assumes x>=0 y>=0 z>=0 etc

//1st row should contain the objective function
//eg a b c +1 0  represents maximize a*x+b*y+c*z
//          0    represents find a feasible solution (ignores a,b,c)
//         -1    represents minimize

//Doesn't modify the input Matrix
//It modifies Result and forces the dimension of Result to be the Matrix Width-2 by 1

//returns  1 on success it fills Result with the solution

//returns -1 if it ran out of memory
//returns -2 if there is no feasible solution
//returns -3 if the solution is unbounded
//returns -4 if the Matrix has dimensions less then 2 by 3
//              (ie must have at least one unkown variable and one constraint)
int SimplexAlgorithm(const CMatrixList& mData, CMatrixList& Result);

#endif

