#ifndef __MOTION_DATA__
#define __MOTION_DATA__

#include "DifferentialEquation.h"
#include "Quaternion.h"

//This holds the physical properties of an object needed for simulation
//On Initialization set:
//  Mass
//	InertiaTensor
//	CoefficientOfRestitution
//	new_Orientation
//	new_Position
//	new_Velocity
//	new_AngularMomentum
class CMotionData
{
public:
	
	CMotionData();

	CMatrix Orientation;
	CVector Position;

	//constants
	double      Mass;//If Mass is -ve then it is assumed to be infinite
	CMatrix     InertiaTensor;//Assumes Mass = 1
	CMatrix     InverseOfTheInertiaTensor;
	double      CoefficientOfRestitution;

	//old Data
	CQuaternion old_Orientation;
	CVector     old_Position;
	CVector     old_Velocity;
	CVector     old_AngularMomentum;//Assumes Mass = 1

	//new Data
	CQuaternion new_Orientation;
	CVector     new_Position;
	CVector     new_Velocity;
	CVector     new_AngularMomentum;
};

#endif

