#ifndef _FILTER_GRAPH_MANAGER_
#define _FILTER_GRAPH_MANAGER_

#include <dshow.h>
#include "VideoCapture.h"

class CFilterGraphManager
{
public:
	CFilterGraphManager();
	~CFilterGraphManager();

	HRESULT Init();
	void Cleanup();

	HRESULT CreateFilterGraph(VideoProperties* prop);
	void End();
	int  GetBufferSize();
	bool AddImage (BYTE* pData, int repeatTime);
	bool AddBitmap(BYTE* pData, int repeatTime);
	
	bool FillCompressorProperties(IBaseFilter** ppFilter, CompressorProperties* cp);
	void SetCompressorProperties(IBaseFilter** ppFilter, CompressorPropertiesToSet* prop);

	bool Error;
	int  LengthOfStr;
	char ErrorString [1000];

	void SetResourceValues(ResourceValues* pRV);
	void DisplayCompressorDialog(HWND phWndParent, VideoProperties* prop);

	void DisplayCompressorProperties(CompressorProperties* cp);
	HRESULT GetAllCompressorInfo(CompressorProperties** pArray);

	bool InitArray(VideoProperties* prop, bool bHasToConnectToSource);
	void CleanupArray();
	bool ReleaseArrayGraph();
	bool WillConnect(VideoProperties* prop, int id);
	void ShowDialog(IBaseFilter** ppFilter, HWND hWndParent, bool bAbout, bool bConfig);
	
	ResourceValues RV;

	IBaseFilter     **CompressorArray;
	int             *QualityArray;
	char            **Name;
	int             noOfCompressorsInArray;
	int             indexOfChosenCompressor;

private:
	void UpdateError(char* str);
	bool CheckVideoProperties(VideoProperties* prop);

	HRESULT AddFilterByCLSID(IGraphBuilder *pGraph,const GUID& clsid,LPCWSTR wszName,IBaseFilter **ppF);
	HRESULT GetUnconnectedPin(IBaseFilter *pFilter,PIN_DIRECTION PinDir,IPin **ppPin);
	HRESULT ConnectFilters(IGraphBuilder *pGraph,IPin *pOut,IBaseFilter *pDest);
	HRESULT ConnectFilters(IGraphBuilder *pGraph,IBaseFilter *pSrc,IBaseFilter *pDest);
	HRESULT FindVideoCompressor(IBaseFilter** ppFilter, char* FindFriendlyName);

	bool CoInit;
	bool HaveFilterGraph;
	bool bEndCalled;

	IGraphBuilder   *pGraph;

	IMediaControl   *pControl;
    IMediaEvent     *pEvent;

	IBaseFilter     *pSource;
	IBaseFilter     *pCompressor;
	IBaseFilter     *pAviMux;
	IBaseFilter     *pFileWriter;
	IBaseFilter     *pAudioRenderer;

	void            *pF;

	int             GraphRunning;//Can be 0 for no graph
								 //       1 for capture graph
								 //       2 for compressor properties
};

#endif