#ifndef __DIFFERENTIAL_EQUATION__
#define __DIFFERENTIAL_EQUATION__

#include "VectorList.h"

//Allocation of arrays (CVectorList objects) should be handled by calling function
typedef void (CalcXdot)(CVectorList* x_dot, CVectorList* x, double t);

//Solves x_dot = f(x,t)
//Allocation of x_start and x_final should be done by calling function
void ode(CVectorList* x_start, CVectorList* x_final,
		 double       t_start, double       t_final,
		 int          steps,   CalcXdot     f);

#endif

