#ifndef __MOTION_DATA__
#define __MOTION_DATA__

#include "DifferentialEquation.h"
#include "Quaternion.h"

//This holds the physical properties of an object needed for simulation
//On Initialization set:
//  Mass
//	InertiaTensor
//	CoefficientOfRestitution
//	new_Orientation
//	new_Position
//	new_Velocity
//	new_AngularMomentum
class CMotionData
{
public:
	
	CMotionData();

	CMatrix Orientation;
	CVector Position;

	//constants
	double      Mass;//If Mass is -ve then it is assumed to be infinite
	double      Inertia;//Assumes Mass = 1
	double      CoefficientOfRestitution;

	//old Data
	double      old_Orientation;
	CVector     old_Position;
	CVector     old_Velocity;
	double      old_AngularMomentum;//Assumes Mass = 1

	//new Data
	double      new_Orientation;
	CVector     new_Position;
	CVector     new_Velocity;
	double      new_AngularMomentum;
};


//Used to help convert states of objects into a form ode solvers can integrate
class CDiffEqMotionData
{
public:

	double  Mass;
	double  Inertia;
	double  Orientation;
	CVector Position; 
	double  AngularMomentum;
	CVector Velocity;
};

#endif

