#ifndef __VECTOR__
#define __VECTOR__

#include <math.h>

class CVector
{
public:
	
	CVector();
	CVector(double X, double Y, double Z);
	CVector(const CVector& v);
	
	void    operator =( const CVector&       v);
	CVector operator -( const CVector&       v) const;
	CVector operator +( const CVector&       v) const;
	CVector operator *(       double    lambda) const;
	CVector operator /(       double    lambda) const;
	void    operator +=(const CVector&       v);
	void    operator -=(const CVector&       v);
	void    operator *=(      double    lambda);
	void    operator /=(      double    lambda);
	
	CVector Cross(const CVector& v) const;
	double  Dot  (const CVector& v) const;
	double  Length()                const;
	void    Normalize();

	double e[3];
	//e[0]=x
	//e[1]=y
	//e[2]=z
};

CVector operator *(double lambda, const CVector& v);

#endif

